#include <initializer_list>
#include <Betriebssystem.h>

namespace KSGScript
{
    class KSGScriptProcessor; // KSGScriptO.h

#define KSGS_WARNING_CreateVar 0
#define KSGS_WARNING_CreateVarTyp 1
#define KSGS_WARNING_CreateVarUnknownTyp 2
#define KSGS_WARNING_OperatorNullPointer 3
#define KSGS_ERROR_FileOpen 4
#define KSGS_ERROR_FileParseWord 5
#define KSGS_ERROR_FileParseX 6
#define KSGS_ERROR_TypRedef 7
#define KSGS_ERROR_FunktionRedef 8
#define KSGS_ERROR_VariableRedef 9
#define KSGS_ERROR_Compile 10
#define KSGS_ERROR_CompileVarTyp 11
#define KSGS_ERROR_CompileFunkTyp 12
#define KSGS_ERROR_CompileOrder 13
#define KSGS_WARNING_CompileArgumentCount 14
#define KSGS_WARNING_CompileFuncReturnDiff 15
#define KSGS_WARNING_ConvertVar 16
#define KSGS_WARNING_NoAccessToPrivateVar 17
#define KSGS_WARNING_NoAccessToPrivateFunk 18
#define KSGS_WARNING_FunkNotFound 19
#define KSGS_WARNING_FunkNotAllParams 20
#define KSGS_WARNING_OperatorUndefined 21
#define KSGS_WARNING_WrongExecutionOfOrder 22

    __declspec( dllexport ) void error( int num, std::initializer_list< const char * > msg, KSGScript::KSGScriptProcessor *zObj );
}