#include "KSGSBildZ.h"
#include "KSGSMausEreignis.h"
#include "../Main/KSGScriptObj.h"
#include "../Error/Error.h"
#include "KSGSTyp.h"
#include "KSGSBool.h"
#include "KSGSBild.h"
#include <ToolTip.h>
#include "KSGSText.h"
#include "KSGSInt.h"

using namespace KSGScript;

// Inhalt der KSGSBildZKlasse Klasse aus KSGSBildZ.h
// Konstruktor
KSGSBildZKlasse::KSGSBildZKlasse( KSGScriptProcessor *zObj, BildZ *std )
    : KSGSKlasseInstanz( KSGS_BILDO, 0, 0, zObj )
{
    val = std;
    val->setMausEreignisParameter( this );
    val->setMausEreignis( ksgsBildZME );
    mausF = -1;
}

// Destruktor
KSGSBildZKlasse::~KSGSBildZKlasse()
{
    val->release();
}

// nicht constant
KSGSVariable *KSGSBildZKlasse::startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter )
{
    KSGSVariable *ret = 0;
    switch( id )
    {
    case 0: // void setBild( Bild )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setBild( parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0 );
        break;
    case 1: // void setRFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setRahmenFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 2: // void setRBreite( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setRahmenBreite( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 3: // void setStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 4: // void addStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->addStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 5: // void lscheStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0, 0 );
        break;
    case 6: // bool tick( double )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        ret = new KSGSBoolKlasse( obj, val->tick( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 7: // void setMausEreignis( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *n = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            if( n )
            {
                mausF = obj->getFunktionId( *n );
                n->release();
            }
            else
                mausF = -1;
        }
        break;
    case 8: // void doMausEreignis( MausEreignis )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            MausEreignis me = parameter->z( 0 ) ? parameter->z( 0 )->getMausEreignis() : MausEreignis{ 0, 0, 0, 0, 1, 0, 0 };
            val->doPublicMausEreignis( me );
        }
        break;
    case 9: // void render( int, int, Bild )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Bild *b = parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0;
            if( b )
            {
                val->render( *b );
                b->release();
            }
        }
        break;
    case 10: // Bild getBild()
        ret = new KSGSBildKlasse( obj, val->getBild() );
        break;
    case 11: // bool hatStyle( int )
        ret = new KSGSBoolKlasse( obj, val->hatStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 12: // bool hatStyleNicht( int )
        ret = new KSGSBoolKlasse( obj, val->hatStyleNicht( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 13: // BildZ dublizieren()
        ret = new KSGSBildZKlasse( obj, (BildZ *)val->dublizieren() );
        break;
    case 14: // void setToolTipText( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *txt = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            val->setToolTipText( txt ? (const char *)*txt : 0, obj->zBildschirm(), obj->zSchrift() );
            if( txt )
                txt->release();
        }
        break;
    case 15: // void setPosition( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setPosition( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                          parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 16: // void setGre( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setSize( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                      parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 17: // int getBreite()
        ret = new KSGSIntKlasse( obj, val->getBreite() );
        break;
    case 18: // int getHhe()
        ret = new KSGSIntKlasse( obj, val->getHeight() );
        break;
    case 19: // int getX()
        ret = new KSGSIntKlasse( obj, val->getX() );
        break;
    case 20: // int getY()
        ret = new KSGSIntKlasse( obj, val->getY() );
        break;
    default: // unbekannt
        error( 19, {}, obj );
        break;
    }
    parameter->release();
    return ret;
}

KSGSVariable *KSGSBildZKlasse::doOperator( int id, KSGSVariable *rechts )
{
    if( !rechts )
    {
        error( 3, {}, obj );
        return 0;
    }
    KSGSVariable *ret = 0;
    switch( id )
    {
    case KSGS_O_SET:
        if( 1 )
        {
            val->release();
            val = rechts->getBildZ();
            ret = dynamic_cast<KSGSVariable *>( getThis() );
        }
        break;
    }
    if( !ret )
        error( 21, {}, obj );
    if( rechts )
        rechts->release();
    return ret;
}

bool KSGSBildZKlasse::doMausEreignis( MausEreignis &me )
{
    if( mausF < 0 )
        return 1;
    RCArray< KSGSVariable > *parameter = new RCArray< KSGSVariable >();
    parameter->add( new KSGSMausEreignisKlasse( obj, me ) );
    KSGSVariable *ret = obj->startFunktion( mausF, parameter );
    if( ret )
    {
        bool r = ret->getBool();
        ret->release();
        return r;
    }
    return 1;
}

// constant
BildZ *KSGSBildZKlasse::getVal() const
{
    return dynamic_cast<BildZ *>( val->getThis() );
}

BildZ *KSGSBildZKlasse::zVal() const
{
    return val;
}


// Ereignisse
bool KSGScript::ksgsBildZME( void *var, void *obj, MausEreignis me )
{
    if( !var )
        return 1;
    return ( (KSGSBildZKlasse *)var )->doMausEreignis( me );
}