#include "KSGSFenster.h"
#include "KSGSTyp.h"
#include "../Error/Error.h"
#include "../Main/KSGScriptObj.h"
#include "KSGSMausEreignis.h"
#include "KSGSTastaturEreignis.h"
#include "KSGSBool.h"
#include "KSGSText.h"
#include "KSGSInt.h"
#include "KSGSBild.h"
#include <Punkt.h>
#include <ToolTip.h>

using namespace KSGScript;

// Inahlt der KSGSFensterKlasse Klasse aus KSGSFenster.h
// Konstruktor
KSGSFensterKlasse::KSGSFensterKlasse( KSGScriptProcessor *zObj, Fenster *std )
    : KSGSKlasseInstanz( KSGS_FENSTER, 0, 0, zObj )
{
    val = std;
    val->setMausEreignisParameter( this );
    val->setMausEreignis( ksgsFensterME );
    val->setTastaturEreignisParameter( this );
    val->setTastaturEreignis( ksgsFensterTE );
    if( zObj->zSchrift() )
        val->setTSchriftZ( dynamic_cast<Schrift *>( zObj->zSchrift()->getThis() ) );
    mausF = -1;
    tastaturF = -1;
}

// Destruktor
KSGSFensterKlasse::~KSGSFensterKlasse()
{
    val->release();
}

// nicht constant
KSGSVariable *KSGSFensterKlasse::startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter )
{
    KSGSVariable *ret = 0;
    switch( id )
    {
    case 0: // void setRFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setRFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 1: // void setRBreite( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setRBreite( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 2: // void setTitel( Text )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTitel( parameter->z( 0 ) ? parameter->z( 0 )->getText() : new Text() );
        break;
    case 3: // void setTSFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTSFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 4: // void setTSGre( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTSSize( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 5: // void setTBgFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTBgFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 6: // void setTAfFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTAfFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 7: // void setTAfStrke( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTAfStrength( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 8: // void setTBgBild( Bild )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTBgBild( parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0 );
        break;
    case 9: // void setTRFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTRFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 10: // void setTRBreite( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setTRBreite( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 11: // void setKBgFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKBgFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 12: // void setKBgBild( Bild )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKBgBild( parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0 );
        break;
    case 13: // void setKAfFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKAfFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 14: // void setKAfStrke( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKAfStrength( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 15: // void setSBgFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSBgFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 16: // void setSBgBild( Bild )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSBgBild( parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0 );
        break;
    case 17: // void setSAfFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSAfFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 18: // void setSAfStrke( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSAfStrength( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 19: // void setSKAfFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSKAfFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 20: // void setSKAfStrke( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSKAfStrength( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 21: // void setMin( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setMin( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                     parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 22: // void setMax( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setMax( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                     parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 23: // void setKMin( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setKMin( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                      parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 24: // void setKMax( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setKMax( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                      parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 25: // void setHSBMax( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setHSBMax( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 26: // void setVSBMax( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setVSBMax( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 27: // void setHSBScroll( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setHSBScroll( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 28: // void setVSBScroll( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setVSBScroll( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 29: // void setStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 30: // void addStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->addStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 31: // void removeStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->removeStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 32: // void addMember( Zeichnung )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Zeichnung *obj = parameter->z( 0 ) ? parameter->z( 0 )->getZeichnung() : 0;
            if( obj )
                val->addMember( dynamic_cast<Zeichnung *>( obj->getThis() ) );
        }
        break;
    case 33: // void removeMember( Zeichnung )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Zeichnung *obj = parameter->z( 0 ) ? parameter->z( 0 )->getZeichnung() : 0;
            if( obj )
                val->removeMember( obj );
        }
        break;
    case 34: // bool tick( double )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        ret = new KSGSBoolKlasse( obj, val->tick( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 35: // void setMausEreignis( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *n = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            if( n )
            {
                mausF = obj->getFunktionId( *n );
                n->release();
            }
            else
                mausF = -1;
        }
        break;
    case 36: // void setTastaturEreignis( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *n = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            if( n )
            {
                tastaturF = obj->getFunktionId( *n );
                n->release();
            }
            else
                tastaturF = -1;
        }
        break;
    case 37: // void doMausEreignis( MausEreignis )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            MausEreignis me = parameter->z( 0 ) ? parameter->z( 0 )->getMausEreignis() : MausEreignis{ 0, 0, 0, 0, 1, 0, 0 };
            val->doPublicMausEreignis( me );
        }
        break;
    case 38: // void doTastaturEreignis( TastaturEreignis )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            TastaturEreignis te = parameter->z( 0 ) ? parameter->z( 0 )->getTastaturEreignis() : TastaturEreignis{ 0, 0, 0 };
            val->doTastaturEreignis( te );
        }
        break;
    case 39: // void render( int, int, Bild )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Bild *b = parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0;
            if( b )
            {
                val->render( *b );
                b->release();
            }
        }
        break;
    case 40: // int getRFarbe()
        ret = new KSGSIntKlasse( obj, val->getRFarbe() );
        break;
    case 41: // int getRBreite()
        ret = new KSGSIntKlasse( obj, val->getRBreite() );
        break;
    case 42: // Tect getTitel()
        ret = new KSGSTextKlasse( obj, val->zTitel() ? val->zTitel()->getText() : "" );
        break;
    case 43: // int getTSFarbe()
        ret = new KSGSIntKlasse( obj, val->getTSFarbe() );
        break;
    case 44: // int getTSGre()
        ret = new KSGSIntKlasse( obj, val->getTSSize() );
        break;
    case 45: // int getTBgFarbe()
        ret = new KSGSIntKlasse( obj, val->getTBgFarbe() );
        break;
    case 46: // int getTAfFarbe()
        ret = new KSGSIntKlasse( obj, val->getTAfFarbe() );
        break;
    case 47: // int getTAfStrke()
        ret = new KSGSIntKlasse( obj, val->getTAfStrength() );
        break;
    case 48: // Bild getTBgBild()
        ret = new KSGSBildKlasse( obj, val->getTBgBild() );
        break;
    case 49: // int getTRFarbe()
        ret = new KSGSIntKlasse( obj, val->getTRFarbe() );
        break;
    case 50: // int getTRBreite()
        ret = new KSGSIntKlasse( obj, val->getTRBreite() );
        break;
    case 51: // int getKBgFarbe()
        ret = new KSGSIntKlasse( obj, val->getKBgFarbe() );
        break;
    case 52: // Bild getKBgBild()
        ret = new KSGSBildKlasse( obj, val->getKBgBild() );
        break;
    case 53: // int getKAfFarbe()
        ret = new KSGSIntKlasse( obj, val->getKAfFarbe() );
        break;
    case 54: // int getKAfStrke()
        ret = new KSGSIntKlasse( obj, val->getKAfStrength() );
        break;
    case 55: // int getSBgFarbe()
        ret = new KSGSIntKlasse( obj, val->getSBgFarbe() );
        break;
    case 56: // Bild getSBgBild()
        ret = new KSGSBildKlasse( obj, val->getSBgBild() );
        break;
    case 57: // int getSAfFarbe()
        ret = new KSGSIntKlasse( obj, val->getSAfFarbe() );
        break;
    case 58: // int getSAfStrke()
        ret = new KSGSIntKlasse( obj, val->getSAfStrength() );
        break;
    case 59: // int getSKAfFarbe()
        ret = new KSGSIntKlasse( obj, val->getSKAfFarbe() );
        break;
    case 60: // int getSKAfStrke()
        ret = new KSGSIntKlasse( obj, val->getSKAfStrength() );
        break;
    case 61: // int getMinBreite()
        ret = new KSGSIntKlasse( obj, val->getMin().x );
        break;
    case 62: // int getMinHhe()
        ret = new KSGSIntKlasse( obj, val->getMin().y );
        break;
    case 63: // int getMaxBreite()
        ret = new KSGSIntKlasse( obj, val->getMax().x );
        break;
    case 64: // int getMaxHhe()
        ret = new KSGSIntKlasse( obj, val->getMax().y );
        break;
    case 65: // int getKMinBreite()
        ret = new KSGSIntKlasse( obj, val->getKMin().x );
        break;
    case 66: // int getKMinHhe()
        ret = new KSGSIntKlasse( obj, val->getKMin().y );
        break;
    case 67: // int getKMaxBreite()
        ret = new KSGSIntKlasse( obj, val->getKMax().x );
        break;
    case 68: // int getKMaxHhe()
        ret = new KSGSIntKlasse( obj, val->getKMax().y );
        break;
    case 69: // bool hatStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        ret = new KSGSBoolKlasse( obj, val->hatStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 70: // bool hatStyleNicht( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        ret = new KSGSBoolKlasse( obj, val->hatStyleNicht( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 71: // Fenster dublizieren()
        ret = new KSGSFensterKlasse( obj, (Fenster *)val->dublizieren() );
        break;
    case 72: // void setToolTipText( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *txt = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            val->setToolTipText( txt ? (const char *)*txt : 0, obj->zBildschirm(), obj->zSchrift() );
            if( txt )
                txt->release();
        }
        break;
    case 73: // void setPosition( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setPosition( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                          parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 74: // void setGre( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setSize( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                      parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 75: // int getBreite()
        ret = new KSGSIntKlasse( obj, val->getBreite() );
        break;
    case 76: // int getHhe()
        ret = new KSGSIntKlasse( obj, val->getHeight() );
        break;
    case 77: // int getX()
        ret = new KSGSIntKlasse( obj, val->getX() );
        break;
    case 78: // int getY()
        ret = new KSGSIntKlasse( obj, val->getY() );
        break;
    default: // unbekannt
        error( 19, {}, obj );
        break;
    }
    parameter->release();
    return ret;
}

KSGSVariable *KSGSFensterKlasse::doOperator( int id, KSGSVariable *rechts )
{
    if( !rechts )
    {
        error( 3, {}, obj );
        return 0;
    }
    KSGSVariable *ret = 0;
    switch( id )
    {
    case KSGS_O_SET:
        if( 1 )
        {
            val->release();
            val = rechts->getFenster();
            ret = dynamic_cast<KSGSVariable *>( getThis() );
        }
        break;
    }
    if( !ret )
        error( 21, {}, obj );
    if( rechts )
        rechts->release();
    return ret;
}

bool KSGSFensterKlasse::doMausEreignis( MausEreignis &me )
{
    if( mausF < 0 )
        return 1;
    RCArray< KSGSVariable > *parameter = new RCArray< KSGSVariable >();
    parameter->add( new KSGSMausEreignisKlasse( obj, me ) );
    KSGSVariable *ret = obj->startFunktion( mausF, parameter );
    if( ret )
    {
        bool r = ret->getBool();
        ret->release();
        return r;
    }
    return 1;
}

bool KSGSFensterKlasse::doTastaturEreignis( TastaturEreignis &te )
{
    if( tastaturF < 0 )
        return 1;
    RCArray< KSGSVariable > *parameter = new RCArray< KSGSVariable >();
    parameter->add( new KSGSTastaturEreignisKlasse( obj, te ) );
    KSGSVariable *ret = obj->startFunktion( tastaturF, parameter );
    if( ret )
    {
        bool r = ret->getBool();
        ret->release();
        return r;
    }
    return 1;
}

// constant
Fenster *KSGSFensterKlasse::getVal() const
{
    return dynamic_cast<Fenster *>( val->getThis() );
}

Fenster *KSGSFensterKlasse::zVal() const
{
    return val;
}

// Ereignisse
bool KSGScript::ksgsFensterME( void *var, void *obj, MausEreignis me )
{
    if( !var )
        return 1;
    return ( (KSGSFensterKlasse *)var )->doMausEreignis( me );
}

bool KSGScript::ksgsFensterTE( void *var, void *obj, TastaturEreignis te )
{
    if( !var )
        return 1;
    return ( (KSGSFensterKlasse *)var )->doTastaturEreignis( te );
}