#include "KSGSKnopf.h"
#include "KSGSTyp.h"
#include "../Error/Error.h"
#include "../Main/KSGScriptObj.h"
#include "KSGSMausEreignis.h"
#include "KSGSText.h"
#include "KSGSInt.h"
#include "KSGSBool.h"
#include "KSGSBild.h"
#include <ToolTip.h>

using namespace KSGScript;

// Inhalt der KSGSKnopfKlasse Klasse aus KSGSKnopf.h
// Konstruktor
KSGSKnopfKlasse::KSGSKnopfKlasse( KSGScriptProcessor *zObj, Knopf *std )
    : KSGSKlasseInstanz( KSGS_KNOPF, 0, 0, zObj )
{
    mausF = -1;
    val = std;
    val->setMausEreignisParameter( this );
    val->setMausEreignis( ksgsKnopfME );
    if( zObj->zSchrift() )
        val->setSchriftZ( dynamic_cast<Schrift *>( zObj->zSchrift()->getThis() ) );
}

// Destruktor
KSGSKnopfKlasse::~KSGSKnopfKlasse()
{
    val->release();
}

// nicht constant
KSGSVariable *KSGSKnopfKlasse::startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter )
{
    KSGSVariable *ret = 0;
    switch( id )
    {
    case 0: // void setText( Text )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setText( parameter->z( 0 ) ? parameter->z( 0 )->getText() : new Text() );
        break;
    case 1: // void setHintergrundBild( Bild )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setHintergrundBildZ( parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0 );
        break;
    case 2: // void setHintergrundFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setHintergrundFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 3: // void setSchriftGre( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSchriftSize( parameter->z( 0 ) ? (unsigned char)parameter->z( 0 )->getInt() : (unsigned char)0 );
        break;
    case 4: // void setSchriftFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setSchriftFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 5: // void setAFStrke( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setAlphaFeldStrength( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 6: // void setAFFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setAlphaFeldFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 7: // void setLRBreite( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setRahmenBreite( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 8: // void setLRFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setRahmenFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 9: // void setKlickFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKlickFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 10: // void setKlickBild( Bild )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKlickBildZ( parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0 );
        break;
    case 11: // void setKBStrke( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKBStrength( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 12: // void setKBFarbe( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setKBFarbe( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 13: // void setStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->setStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 14: // void addStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->addStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 15: // void lscheStyle( int )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        val->removeStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 );
        break;
    case 16: // bool tick( double )
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        ret = new KSGSBoolKlasse( obj, val->tick( parameter->z( 0 ) ? parameter->z( 0 )->getDouble() : 0 ) );
        break;
    case 17: // void setMausEreignis( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *n = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            if( n )
            {
                mausF = obj->getFunktionId( *n );
                n->release();
            }
            else
                mausF = -1;
        }
        break;
    case 18: // void doMausEreignis( MausEreignis )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            MausEreignis me = parameter->z( 0 ) ? parameter->z( 0 )->getMausEreignis() : MausEreignis{ 0, 0, 0, 0, 1, 0, 0 };
            val->doPublicMausEreignis( me );
        }
        break;
    case 19: // void render( int, int, Bild )if( 1 )
    {
        if( parameter->getEintragAnzahl() < 1 )
            error( 20, {}, obj );
        Bild *b = parameter->z( 0 ) ? parameter->z( 0 )->getBild() : 0;
        if( b )
        {
            val->render( *b );
            b->release();
        }
    }
    break;
    case 20: // Text getText()
        if( 1 )
        {
            Text *txt = val->getText();
            ret = new KSGSTextKlasse( obj, *txt );
            txt->release();
        }
        break;
    case 21: // Bild getHintergrundBild()
        ret = new KSGSBildKlasse( obj, val->getHintergrundBild() );
        break;
    case 22: // int getHintergrundFarbe()
        ret = new KSGSIntKlasse( obj, val->getHintergrundFarbe() );
        break;
    case 23: // int getSchriftGre()
        ret = new KSGSIntKlasse( obj, val->getSchriftSize() );
        break;
    case 24: // int getSchriftFarbe()
        ret = new KSGSIntKlasse( obj, val->getSchriftFarbe() );
        break;
    case 25: // int getAFStrke()
        ret = new KSGSIntKlasse( obj, val->getAlphaFeldStrength() );
        break;
    case 26: // int getAFFarbe()
        ret = new KSGSIntKlasse( obj, val->getAlphaFeldFarbe() );
        break;
    case 27: // int getLRBreite()
        ret = new KSGSIntKlasse( obj, val->getRahmenBreite() );
        break;
    case 28: // int getLRFarbe()
        ret = new KSGSIntKlasse( obj, val->getRahmenFarbe() );
        break;
    case 29: // int getKlickFarbe()
        ret = new KSGSIntKlasse( obj, val->getKlickFarbe() );
        break;
    case 30: // Bild getKlickBild()
        ret = new KSGSBildKlasse( obj, val->getKlickBild() );
        break;
    case 31: // int getKBFarbe()
        ret = new KSGSIntKlasse( obj, val->getKBFarbe() );
        break;
    case 32: // int getKBStrke()
        ret = new KSGSIntKlasse( obj, val->getKBStrength() );
        break;
    case 33: // bool hatStyle( int )
        ret = new KSGSBoolKlasse( obj, val->hatStyle( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 34: // bool hatStyleNicht( int )
        ret = new KSGSBoolKlasse( obj, val->hatStyleNicht( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0 ) );
        break;
    case 35: // Knopf dublizieren()
        ret = new KSGSKnopfKlasse( obj, (Knopf *)val->dublizieren() );
        break;
    case 36: // void setToolTipText( Text )
        if( 1 )
        {
            if( parameter->getEintragAnzahl() < 1 )
                error( 20, {}, obj );
            Text *txt = parameter->z( 0 ) ? parameter->z( 0 )->getText() : 0;
            val->setToolTipText( txt ? (const char *)*txt : 0, obj->zBildschirm(), obj->zSchrift() );
            if( txt )
                txt->release();
        }
        break;
    case 37: // void setPosition( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setPosition( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                          parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 38: // void setGre( int, int )
        if( parameter->getEintragAnzahl() < 2 )
            error( 20, {}, obj );
        val->setSize( parameter->z( 0 ) ? parameter->z( 0 )->getInt() : 0,
                      parameter->z( 1 ) ? parameter->z( 1 )->getInt() : 0 );
        break;
    case 39: // int getBreite()
        ret = new KSGSIntKlasse( obj, val->getBreite() );
        break;
    case 40: // int getHhe()
        ret = new KSGSIntKlasse( obj, val->getHeight() );
        break;
    case 41: // int getX()
        ret = new KSGSIntKlasse( obj, val->getX() );
        break;
    case 42: // int getY()
        ret = new KSGSIntKlasse( obj, val->getY() );
        break;
    default: // unbekannt
        error( 19, {}, obj );
        break;
    }
    parameter->release();
    return ret;
}

KSGSVariable *KSGSKnopfKlasse::doOperator( int id, KSGSVariable *rechts )
{
    if( !rechts )
    {
        error( 3, {}, obj );
        return 0;
    }
    KSGSVariable *ret = 0;
    switch( id )
    {
    case KSGS_O_SET:
        if( 1 )
        {
            val->release();
            val = rechts->getKnopf();
            ret = dynamic_cast<KSGSVariable *>( getThis() );
        }
        break;
    }
    if( !ret )
        error( 21, {}, obj );
    if( rechts )
        rechts->release();
    return ret;
}

bool KSGSKnopfKlasse::doMausEreignis( MausEreignis &me )
{
    if( mausF < 0 )
        return 1;
    RCArray< KSGSVariable > *parameter = new RCArray< KSGSVariable >();
    parameter->add( new KSGSMausEreignisKlasse( obj, me ) );
    KSGSVariable *ret = obj->startFunktion( mausF, parameter );
    if( ret )
    {
        bool r = ret->getBool();
        ret->release();
        return r;
    }
    return 1;
}

// constant
Knopf *KSGSKnopfKlasse::getVal() const
{
    return dynamic_cast<Knopf *>( val->getThis() );
}

Knopf *KSGSKnopfKlasse::zVal() const
{
    return val;
}


// Ereignisse
bool KSGScript::ksgsKnopfME( void *var, void *obj, MausEreignis me )
{
    if( !var )
        return 1;
    return ( (KSGSKnopfKlasse *)var )->doMausEreignis( me );
}