#ifndef KSGSTextFeld_H
#define KSGSTextFeld_H

#include "../Befehl/KSGSKlasse.h"
#include <TextFeld.h>

namespace KSGScript
{
    class KSGSTextFeldKlasse : public KSGSKlasseInstanz
    {
    private:
        TextFeld *val;
        int mausF;
        int tastaturF;

    public:
        // Konstruktor
        __declspec( dllexport ) KSGSTextFeldKlasse( KSGScriptProcessor *zObj, TextFeld *std = new TextFeld() );
        // Destruktor
        __declspec( dllexport ) ~KSGSTextFeldKlasse();
        // nicht constant
        __declspec( dllexport ) virtual KSGSVariable *startFunktion( int id, bool access, RCArray< KSGSVariable > *parameter ) override;
        __declspec( dllexport ) virtual KSGSVariable *doOperator( int id, KSGSVariable *rechts ) override;
        __declspec( dllexport ) virtual bool doMausEreignis( MausEreignis &me );
        __declspec( dllexport ) virtual bool doTastaturEreignis( TastaturEreignis &te );
        // constant
        __declspec( dllexport ) virtual TextFeld *getVal() const;
        __declspec( dllexport ) virtual TextFeld *zVal() const;
    };

    // Ereignisse
    __declspec( dllexport ) bool ksgsTextFeldME( void *var, void *obj, MausEreignis me );
    __declspec( dllexport ) bool ksgsTextFeldTE( void *var, void *obj, TastaturEreignis te );
}

#endif